KCAPI_AKCIPHER_ENCRY(3)

NAME
kcapi_akcipher_encrypt_aio - encrypt data (asynchronous one shot)

SYNOPSIS

ssize_t kcapi_akcipher_encrypt_aio(struct kcapi_handle * handle, struct iovec * iniov, struct iovec * outiov, size_t iovlen, int access);

ARGUMENTS

handle
    [in] cipher handle

iniov
    [in] head of scatter-gather list array holding the plaintext

outiov
    [out] head of scatter-gather list of the destination buffers filled with ciphertext

iovlen
    [in] number of scatter-gather list entries

access
    [in] kernel access type (KCAPI_ACCESS_HEURISTIC - use internal heuristic for fastest kernel access; KCAPI_ACCESS_VMSPLICE - use vmsplice access; KCAPI_ACCESS_SENDMSG - sendmsg access)

DESCRIPTION

The individual scatter-gather list entries are processed with separate invocations of the the given cipher.

The memory should be aligned at the page boundary using posix_memalign(sysconf(_SC_PAGESIZE)), If it is not aligned at the page boundary, the vmsplice call may not send all data to the kernel.

return number of bytes encrypted upon success; a negative errno-style error code if an error occurred

AUTHOR

Stephan Mueller <smueller@chronox.de>
    Author.

COPYRIGHT